﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Net;
using System.Threading;
using System.Drawing;

namespace MapViewer
{
    public class MapFetcher
    {
        private string server;
        private int port;

        private List<MapDataRequest> queue = new List<MapDataRequest>();

        Thread queueProcessor;

        public Bitmap notLoaded;

        public void Start() {
            queueProcessor = new Thread(processQueue);
            queueProcessor.Start();
        }

        public void Stop() {
            try
            {
                queueProcessor.Abort();
            }
            catch { }
        }


        public MapFetcher(string server, int port) {
            this.server = server;
            this.port = port;
            this.notLoaded = new Bitmap(256, 256);
            using (Graphics g = Graphics.FromImage(notLoaded)) 
            {
                g.Clear(Color.Black);
                g.DrawString("Please wait..", new Font(FontFamily.GenericSerif, 10), new SolidBrush(Color.Red), new PointF(0, 0));
            }
           
        }

        private void getImageFromCache(int z,int x, int y) {
            
        }

        private string getUrl(int z, int x, int y) {
            return "http://" + server + ":" + port + "/" + z + "/" + x + "/" + y + ".jpg";
        }

        public Bitmap getSquare(int z, int x, int y) {
            try
            {
                string url = getUrl(z, x, y);
                HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
                request.AllowWriteStreamBuffering = true;
                HttpWebResponse response = (HttpWebResponse)request.GetResponse();
                Bitmap bmp = new Bitmap(response.GetResponseStream());
                response.Close();
                return bmp;
            }
            catch { return null; }
        }


        public bool abortRequest(MapDataRequest request) 
        {
            if (!this.queue.Contains(request)) return false;
            queue.Remove(request);
            return true;
        }

        void processQueue() 
        {
            while (queue.Count > 0) 
            {
                MapDataRequest r = queue.First();
                queue.RemoveAt(0);
                Bitmap bmp = getSquare(r.z,r.x, r.y);
                if (bmp != null)
                {
                    r.bitmap = bmp;
                    r.callback.Invoke(r, bmp);
                }
                else {
                    queue.Add(r);
                }
            }
            Thread.Sleep(100);
            processQueue();
            
        }

        public void getSquare(MapDataRequest request)
        {
            request.bitmap = this.notLoaded;
            queue.Add(request);
        }

        public void Clear() {
            queue.Clear();
        }
    }
}
