﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Threading;

namespace MapViewer
{
    public class Roads
    {
        private string server;
        private int port;

        public bool loaded = false;

        public Dictionary<string, Road> roads = new Dictionary<string, Road>();

        public struct Road
        {
            public List<Crossroad> crossroads;
            public List<int> crossroadIds;
            public string color;
        }

        public struct Crossroad
        {
            public string name;
            int id;
            public int x,y;
        }

        public Roads(string server, int port) 
        {
            this.server = server;
            this.port = port;
        }

        public void Load(ThreadStart callback = null) 
        {
            new Thread(delegate() {
            string url = "http://" + server + ":" + port + "/trasy.xml";
            XmlDocument doc = new XmlDocument();
            doc.Load(url);
            foreach (XmlNode n in doc.DocumentElement.ChildNodes) 
            {
                    if( !roads.ContainsKey(n.Attributes["barva"].Value))
                        roads.Add(n.Attributes["barva"].Value, new Road { color = n.Attributes["barva"].Value, crossroads = new List<Crossroad>() , crossroadIds = new List<int>()});
                    foreach (XmlNode c in n.ChildNodes) 
                    {
                       roads[n.Attributes["barva"].Value].crossroadIds.Add(int.Parse(c.Attributes["id"].Value));
                    } 
                   
            }
            url = "http://" + server + ":" + port + "/rozcestniky.xml";
            doc = new XmlDocument();
            doc.Load(url);

            foreach (XmlNode n in doc.DocumentElement.ChildNodes) 
            {
                int id = int.Parse(n.Attributes["id"].Value);
                foreach (Road r in roads.Where(x => x.Value.crossroadIds.Contains(id)).Select(x => x.Value)) 
                {
                    r.crossroads.Add(new Crossroad{name = n.Attributes["jmeno"] != null ?n.Attributes["jmeno"].Value : "", x = int.Parse(n.Attributes["x"].Value),y = int.Parse(n.Attributes["y"].Value)});
                }
            }
            loaded = true;
            if (callback != null) callback.Invoke();
            }).Start();
            
          
        }
    }
}
